#include<bits/stdc++.h>

#define pb push_back
#define forn(i, l, n) for(int i = l; i < n; i++)

using namespace std;

typedef long long ll;

const ll MOD = 1e9 + 7;

template<class T>
ostream& operator<< (ostream &out, vector<T> &a){
    forn(i, 0, a.size()){
        out << a[i] << " ";
    }
    return out;
}

ll n, cnt = 0;
vector<vector<ll> > comb;

vector<bool> used;

void dfs(ll v, vector<ll> p){
    if((ll)p.size() == n){
        ll inc = 0;
        forn(i, 0, n){
            if((comb[p[i]][0] + comb[p[i]][1] + inc) % 10 != comb[p[i]][2]){
                return;
            }
            inc = (comb[p[i]][0] + comb[p[i]][1] + inc) / 10;
        }
        if(comb[p.back()][0] == 0 || comb[p.back()][1] == 0 || comb[p.back()][2] == 0)
            return;
        if(inc)
            return;
        cnt = (cnt + 1) % MOD;
        return;
    }
    used[v] = 1;
    forn(i, 0, n){
        if(!used[i]){
            p.pb(i);
            dfs(i, p);
            p.pop_back();
        }
    }
    used[v] = 0;
}

int main(){
    string a, b, c;
    cin >> a >> b >> c;
    n = a.size();

    comb.resize(n, vector<ll>(3));

        forn(j, 0, n){
            comb[j][0] = a[j] - '0';
            comb[j][1] = b[j] - '0';
            comb[j][2] = c[j] - '0';
        }

    forn(i, 0, n){
        used.assign(n, 0);
        vector<ll> p;
        p.pb(i);
        dfs(i, p);
        p.clear();
    }
    cout << cnt % MOD;
}
