#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define forn(i, l, n) for(int i = l; i < n; i++)

using namespace std;

typedef long long ll;
typedef long double ld;


ll n, m;
ll first_col;
ll last_col;
ll first_row;
ll last_row;

ll f1(ll mid){
    ll pre_x_col = first_col + n * (mid - 1);
    ll x_col = pre_x_col + n;
    ll left = (first_col + pre_x_col) * mid / 2;
    ll right = (x_col + last_col) * (m - mid) / 2;
    return right - left;
}

ll f2(ll mid){
    ll pre_x_row = first_row + m * m * (mid - 1);
    ll x_row = pre_x_row + m * m;
    ll top = (first_row + pre_x_row) * (mid) / 2;
    ll down = (x_row + last_row) * (n - mid) / 2;
    return top - down;
}

void solve(){
    cin >> n >> m;
    ll ans1 = 0, ans2 = 0;
    ll x1 = -1, x2 = -1;

    first_col  = (1 + (n - 1) * m + 1) * n / 2;
    last_col = first_col + n * (m - 1);
    ll l = -1, r = m, mid;
    while(r - l > 1){                                    // 0 
        mid = (l + r) / 2;
        ll pre_x_col = first_col + n * (mid - 1);
        ll x_col = pre_x_col + n;
        ll left = (first_col + pre_x_col) * mid / 2;
        ll right = (x_col + last_col) * (m - mid) / 2;
        if(right - left > 0){
            l = mid;
        }
        else{
            r = mid;
        }
    }

    //cout << l << " " << r << "qwe\n";
    forn(i, max((ll)0, l - 2), min(m, r) + 3){
        //cout << i << " " << f1(i) << " " << ans1 << endl;
        if(abs(f1(i)) < abs(ans1) && i <= m || x1 == -1){
            ans1 = f1(i);
            x1 = i + 1;
        }
    }

    first_row = (1 + m) * m / 2;
    last_row = first_row + m * m * (n - 1);
    //cout << first_row << " " << last_row << endl;
    l = -1; r = n;
    while(r - l > 1){                                      // 1 
        mid = (l + r) / 2;
        ll pre_x_row = first_row + m * m * (mid - 1);
        ll x_row = pre_x_row + m * m;
        ll top = (first_row + pre_x_row) * (mid) / 2;
        ll down = (x_row + last_row) * (n - mid) / 2;

        //cout << pre_x_row << " " << mid << " " << top << " " << down << endl;

        if(top - down < 0){
            l = mid;
        }
        else{
            r = mid;
        }
    }

    forn(i, max((ll)0, l - 4), min(n + 2, r + 2)){
        //cout << i << " " << f2(i) << " " << ans2 << endl;
        if(abs(f2(i)) < abs(ans2) && i <= n || x2 == -1){
            ans2 = f2(i);
            x2 = i + 1;
        }
    }

    //cout << x1 << " " << x2 << " ";
    if(n == 1 && m == 1){
        cout << "V 0\n";
        return;
    }
    if(n == 1){
        cout << "V " << x1 << "\n";
        return;
    }
    if(m == 1){
        cout << "H " << x2 << "\n";
        return;
    }
    if(abs(ans1) <= abs(ans2)){
        cout << "V " << x1 << "\n";
    }
    else{
        cout << "H " << x2 << "\n";
    }
}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int t =1;
    cin >> t;
    while(t--){
        solve();
    }
}
