#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define forn(i, l, n) for(int i = l; i < n; i++)

using namespace std;

typedef long long ll;
typedef long double ld;

template<class T>
istream& operator>> (istream &in, vector<T> &a){
    forn(i, 0, a.size()){
        in >> a[i];
    }
    return in;
}

template<class T>
ostream& operator<< (ostream &out, vector<T>& a){
    forn(i, 0, a.size()){
        out << a[i] << " ";
    }
    return out;
}

struct sht{
    int len, used;
    vector<int> m;
    sht(int _s, vector<int> _m){
        len = _s;
        m = _m;
        used = 0;
    }
};

int n;
vector<sht> shts;

void dfs(int v, int len, vector<int> pos){
    if(len == n){
        //cout << pos << endl;
        int d = -1;
        int x1 = shts[pos[0]].m[0];
        int step = 0;
        forn(i, 0, n){
            sht th = shts[pos[i]];
            forn(j, 0, th.m.size()){
                if(i == 0 && j == 0)
                    continue;

                if(d == -1){
                    d = th.m[j] + step - x1;
                    //cout << th.m[j] << " " << step << endl;
                    x1 += d;
                    continue;
                }
                //cout << d << endl;
                if(th.m[j] + step - x1 != d){
                    return;
                }
                else{
                    x1 += d;
                }
            }
            step += th.len;
        }
        cout << "Yes\n";
        forn(i, 0, n){
            cout << pos[i] + 1 << " ";
        }
        exit(0);
    }

    shts[v].used = 1;
    forn(i, 0, n){
        if(!shts[i].used){
            pos.pb(i);
            dfs(i, len + 1, pos);
            pos.pop_back();
        }
    }
    shts[v].used = 0;
}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n;
    forn(i, 0, n){
        int m, s;
        cin >> m >> s;
        vector<int> args(m);
        cin >> args;
        sht a = sht(s, args);
        shts.pb(a);
    }
    forn(i, 0, n){
        vector<int> pos;
        pos.pb(i);
        shts[i].used = 1;
        dfs(i, 1, pos);
        shts[i].used = 0;
    }
    cout << "No";
}
